package data.missions.dara_dogfight;

import java.util.ArrayList;
import java.util.List;

import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

public class MissionDefinition implements MissionDefinitionPlugin {

	private List ships = new ArrayList();
	//private void addShip(String variant, int weight) {
	//	for (int i = 0; i < weight; i++) {
	//		ships.add(variant);
	//	}
	//}
	
	private void generateFleet(FleetSide side, List ships, MissionDefinitionAPI api) {

		if (side == FleetSide.PLAYER) {
			String [] choices = {
					"dara_cayman_Heavy",
					"dara_rogue_Interceptor",
					"dara_warhammer_Superheavy",
					"dara_thunder_Luddic"
			};

			String flagship = choices[(int) (Math.random() * (float) choices.length)];
			api.addToFleet(side, flagship, FleetMemberType.SHIP, true);

//			api.addToFleet(side, "dara_cayman_Heavy", FleetMemberType.SHIP, true);
		} else {
			String [] choices = {
					"mining_drone_wing"
			};
			String wing = choices[(int) (Math.random() * (float) choices.length)];
			api.addToFleet(side, wing, FleetMemberType.FIGHTER_WING, false);
		}
	}
	
	@Override
	public void defineMission(MissionDefinitionAPI api) {
		
		// Set up the fleets so we can add ships and fighter wings to them.
		// In this scenario, the fleets are attacking each other, but
		// in other scenarios, a fleet may be defending or trying to escape
		api.initFleet(FleetSide.PLAYER, "", FleetGoal.ATTACK, false, 5);
		api.initFleet(FleetSide.ENEMY, "", FleetGoal.ATTACK, true, 5);

		// Set a small blurb for each fleet that shows up on the mission detail and
		// mission results screens to identify each side.
		api.setFleetTagline(FleetSide.PLAYER, "Your forces");
		api.setFleetTagline(FleetSide.ENEMY, "Enemy forces");
		
		// These show up as items in the bulleted list under 
		// "Tactical Objectives" on the mission detail screen
		api.addBriefingItem("Defeat the enemy Ace");
		api.addBriefingItem("Click on the mission again to reroll the ships");
		
		// Set up the fleets
		generateFleet(FleetSide.PLAYER, ships, api);
		generateFleet(FleetSide.ENEMY, ships, api);
		//api.addToFleet(FleetSide.PLAYER, "dara_cayman_Heavy", FleetMemberType.SHIP, true);
		//api.addToFleet(FleetSide.ENEMY, "dara_cayman_Heavy", FleetMemberType.SHIP, true);
		
		// Set up the map.
		float width = 10000f;
		float height = 10000f;
		api.initMap((float)-width/2f, (float)width/2f, (float)-height/2f, (float)height/2f);
		
		float minX = -width/2;
		float minY = -height/2;
		
		
		//for (int i = 0; i < 50; i++) {
		//	float x = (float) Math.random() * width - width/2;
		//	float y = (float) Math.random() * height - height/2;
		//	float radius = 100f + (float) Math.random() * 400f; 
		//	api.addNebula(x, y, radius);
		//}
		
		// Add objectives
		//api.addObjective(minX + width * 0.25f + 2000, minY + height * 0.25f + 2000, "nav_buoy");
		//api.addObjective(minX + width * 0.75f - 2000, minY + height * 0.25f + 2000, "comm_relay");
		//api.addObjective(minX + width * 0.75f - 2000, minY + height * 0.75f - 2000, "nav_buoy");
		//api.addObjective(minX + width * 0.25f + 2000, minY + height * 0.75f - 2000, "comm_relay");
		//api.addObjective(minX + width * 0.5f, minY + height * 0.5f, "sensor_array");
		
		//String [] planets = {"barren", "terran", "gas_giant", "ice_giant", "cryovolcanic", "frozen", "jungle", "desert", "arid"};
		//String planet = planets[(int) (Math.random() * (double) planets.length)];
		//float radius = 100f + (float) Math.random() * 150f;
		//api.addPlanet(0, 0, radius, planet, 200f, true);
	}

}





