package data.missions.dara_race02;

import com.fs.starfarer.api.combat.BattleCreationContext;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.impl.combat.EscapeRevealPlugin;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

import java.util.ArrayList;
import java.util.List;

import com.fs.starfarer.api.impl.campaign.ids.Personalities;
//import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;

public class MissionDefinition implements MissionDefinitionPlugin {

	private List ships = new ArrayList();
    
    private void generateFleet(FleetSide side, List ships, MissionDefinitionAPI api) {

	String [] choices = {
		"dara_arrow_racer_131_Hull",
		"dara_arrow_racer_yellow_Hull",
		"dara_arrow_racer_red_Hull",
		"dara_arrow_racer_blue_Hull",
        "dara_arrow_racer_aqua_Hull",           // Contributed by Vayra
        "dara_arrow_racer_black_Hull",
        "dara_arrow_racer_bluechecker_Hull",    // Contributed by HELMUT
        "dara_arrow_racer_green_Hull",          // Contributed by HELMUT
        "dara_arrow_racer_ice_Hull",            // Contributed by HELMUT
        "dara_arrow_racer_marshmallow_Hull",    // Contributed by HELMUT
        "dara_arrow_racer_redstar_Hull",        // Contributed by HELMUT
        "dara_arrow_racer_spider_Hull"          // Contributed by HELMUT
    };

	String flagship = choices[(int) (Math.random() * (float) choices.length)];
	api.addToFleet(side, flagship, FleetMemberType.SHIP, true);
	}

	public void defineMission(MissionDefinitionAPI api) {

		// Set up the fleets so we can add ships and fighter wings to them.
		// In this scenario, the fleets are attacking each other, but
		// in other scenarios, a fleet may be defending or trying to escape
		api.initFleet(FleetSide.PLAYER, "", FleetGoal.ATTACK, false, -2);
		api.initFleet(FleetSide.ENEMY, "", FleetGoal.ESCAPE, true);

		// Set a small blurb for each fleet that shows up on the mission detail and
		// mission results screens to identify each side.
		api.setFleetTagline(FleetSide.PLAYER, "Your ship and competitors");
		api.setFleetTagline(FleetSide.ENEMY, "Course marker");
		
		// These show up as items in the bulleted list under 
		// "Tactical Objectives" on the mission detail screen
        api.addBriefingItem("Beat your opponents to the finish line");
		
		// Friendly ships
        generateFleet(FleetSide.PLAYER, ships, api);

		// Enemy forces
		api.addToFleet(FleetSide.ENEMY, "dara_slalomflag_green_Hull", FleetMemberType.SHIP, true);


		//api.defeatOnShipLoss("HSS Red Mist Descends");
		
		// Set up the map.
		float width = 8000f;
		float height = 24000f;
		api.initMap((float)-width/2f, (float)width/2f, (float)-height/2f, (float)height/2f);
		
		float minX = -width/2;
		float minY = -height/2;
		
		// Add an asteroid field
		api.addAsteroidField(0f, 0f, 0, 20000f,
								20f, 0f, 250);
		
		api.addPlanet(0, 0, 50f, "star_yellow", 250f, true);
		
	}

}
