package data.scripts;

import java.util.ArrayList;
import java.util.List;
import java.awt.Color;

import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.combat.BattleObjectiveAPI;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.impl.campaign.skills.ElectronicWarfareScript;

import com.fs.starfarer.api.impl.combat.BaseBattleObjectiveEffect;
import com.fs.starfarer.api.combat.DamagingProjectileAPI;

public class dara_ObjMinefieldEffect extends BaseBattleObjectiveEffect {

	public static final float MINEFIELD_FOG_LIFT_RADIUS = 999f;

	public static final float MINEFIELD_NUM_MINES = 12f;
	//public static final float MINEFIELD_MINE_DAMAGE = 1000f;
	
	private List<ShipStatusItem> items = new ArrayList<ShipStatusItem>();
	private String id;
	
	public void init(CombatEngineAPI engine, BattleObjectiveAPI objective) {
		super.init(engine, objective);
		id = "dara_minefield_effect_" + objective.toString();
		
	}

	public void advance(float amount) {
		
		revealArea(MINEFIELD_FOG_LIFT_RADIUS);
		
		if (objective.getOwner() == 100) {
			return;
		}
		//engine.addFloatingText(objective.getLocation(), "" + (objective.getOwner()), 20, new Color(175,175,255,255), objective, 1.0f, 1.0f);

		int COUNT = 0;
		int MAX = (int) MINEFIELD_NUM_MINES;

		for (DamagingProjectileAPI item : engine.getProjectiles()) {
			//engine.addFloatingText(objective.getLocation(), "" + item.getProjectileSpecId(), 20, new Color(175,175,255,255), objective, 1.0f, 1.0f);
			if (item.getProjectileSpecId().equals("dara_mine_proj")) {
				//engine.addFloatingText(item.getLocation(), "" + (int) item.getElapsed(), 20, new Color(175,175,255,255), item, 1.0f, 1.0f);
				if (item.getElapsed() > 15f) {
					engine.removeEntity(item);
				}
				//engine.addFloatingText(objective.getLocation(), "Found one!", 20, new Color(175,175,255,255), objective, 1.0f, 1.0f);
				COUNT = (COUNT + 1);
			}
		}
		//engine.addFloatingText(objective.getLocation(), "" + COUNT, 20, new Color(175,175,255,255), objective, 1.0f, 1.0f);
		if (COUNT < MAX) {		// This should spawn one bomb per frame until it reaches the MAX number on the battlefield.
			engine.spawnProjectile(null, null, "dara_mine_faux", objective.getLocation(), (float) (360f * Math.random()), null);
		}
	}


	public String getLongDescription() {
		return String.format(
				"deploys proximity mines");
				//"reduces weapon range\n" +
				//"for side with lower ECM rating\n\n" +
				//"%d%% base maximum reduction\n" + 
				//"can be improved by skills",
				//(int)ElectronicWarfareScript.PER_JAMMER,
				//(int)ElectronicWarfareScript.BASE_MAXIMUM);
//		   return String.format(
//				   "command points: +%s\n" +
//				   "reveal area: %d\n" +
//				   "\n" +
//				   //"ship weapon range: +%d%%\n" +
//				   "damage: +%d%%\n",
//				   //"no bonus to fighters\n" +
//				   //"no bonus to frigates",
//				   SENSOR_ARRAY_COMMAND_POINTS,
//				   (int) SENSOR_ARRAY_FOG_LIFT_RADIUS,
//				   (int) SENSOR_ARRAY_DAMAGE_BONUS);
	}
	
	public List<ShipStatusItem> getStatusItemsFor(ShipAPI ship) {
//		if (ship.getOwner() == objective.getOwner()) {
////			if (ship.isFighter()) {
////				return itemsNAFighters;
////			}
////			if (ship.isFrigate()) {
////				return itemsNAFrigates;
////			}
//			return items;
//		}
		return null;
	}
}







