package data.scripts;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.PluginPick;
import com.fs.starfarer.api.campaign.CampaignPlugin;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.combat.MissileAIPlugin;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.campaign.SectorAPI;

import data.scripts.weapons.ai.dara_JudgmentSpireAI;
import data.scripts.world.dara_SectorGen;

import exerelin.campaign.SectorManager;

public class dara_ModPlugin extends BaseModPlugin
{
    // Missiles and weapons that use custom AI
    public static final String JUDGEMENT_MISSILE_ID = "dara_seraphimmain_shot";

    @Override
    public void onApplicationLoad()
    {
        boolean hasLazyLib = Global.getSettings().getModManager().isModEnabled("lw_lazylib");
        if (!hasLazyLib)
        {
            throw new RuntimeException("Disassemble Reassemble requires LazyLib!"
                    + "\nGet it at http://fractalsoftworks.com/forum/index.php?topic=5444");
        }
    }
    
    @Override
    public PluginPick<MissileAIPlugin> pickMissileAI(MissileAPI missile, ShipAPI launchingShip)
    {
        switch (missile.getProjectileSpecId())
        {
            case JUDGEMENT_MISSILE_ID:
                return new PluginPick<MissileAIPlugin>(new dara_JudgmentSpireAI(missile, launchingShip),
                        CampaignPlugin.PickPriority.MOD_SET);
            default:
                return null;
        }
    }
    
    @Override
    public void onNewGame() {
        if (!Global.getSettings().getModManager().isModEnabled("nexerelin") || SectorManager.getCorvusMode()){
            new dara_SectorGen().generate(Global.getSector());
        }
    }
}
