package data.scripts.hullmods;

import java.awt.Color;
import java.util.HashMap;
import java.util.WeakHashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipSystemAPI;
import com.fs.starfarer.api.combat.ShipSystemAPI.SystemState;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.impl.campaign.ids.HullMods;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.combat.DamageType;

import org.lwjgl.util.vector.Vector2f;
import org.lazywizard.lazylib.MathUtils;

public class dara_Racer extends BaseHullMod {

	private static final float SIGHT_RANGE_BONUS = 100f;	// 100x sight radius in combat
        private static final float RACE_GRACE_PERIOD = 3.0f;      // Delay on mission start before stuff happens
        private static final float R1_HULLMOD_PENALTY = 10f;    // Time penalty incurred for each hullmod installed
        private static final float R2_HULLMOD_PENALTY = 10f;    // Time penalty incurred for each hullmod installed
        private static final float R2_INIT_TIME = 300f;         // Race 2 timer starts here
        
        
        private float counter = 0f;
        private float graceCounter = RACE_GRACE_PERIOD;
        private int numMods = 0;
        private boolean raceInitOnce = false;
        private boolean displayTimeOnce = false;
        
        private boolean race01Done = false;
        private boolean race02Done = false;
        
        //private final float baseDecel = 90f;                // Red Arrow's base deceleration value as in ship_data.csv
        //private float checkTimer = 0f;
        //private final float timerDelay = 0.2f;              // Every 0.2 seconds
        //private final float baseDecelMod = baseDecel * timerDelay;
        //private float lastSpeedCheck = 0f;
        //private float nextSpeedCheck = 0f;
        //private float mult = 2.0f;
        
        /*private static final String CDATA_ID = "racer_cdata";
        private final Map<ShipAPI, RacerData> racerData = getRacerData();

        private static Map<ShipAPI, RacerData> getRacerData()
        {
            final Map<String, Object> cData = Global.getCombatEngine().getCustomData();
            Map<ShipAPI, RacerData> data = (Map<ShipAPI, RacerData>) cData.get(CDATA_ID);
            if (data == null)
            {
                data = new HashMap<>();
                cData.put(CDATA_ID, data);
            }
            return data;
        }*/

        //private float cumulativeDmg = 0f;
        
        public static final Color DISPLAY_COLOUR = new Color(100,255,100,255);
        protected Object STATUSKEY1 = new Object();
	protected Object STATUSKEY2 = new Object();
        protected Object STATUSKEY3 = new Object();
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {

		stats.getSightRadiusMod().modifyMult(id, (1f + SIGHT_RANGE_BONUS));
	}
        @Override
        public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {
            //numMods = ship.getVariant().getNonBuiltInHullmods().size();
            //counter = (R1_HULLMOD_PENALTY * numMods);
            raceInitOnce = false;
            race01Done = false;
            race02Done = false;
            graceCounter = RACE_GRACE_PERIOD;
            
        }
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		//if (index == 1) return "" + (int) (100f * SIGHT_RANGE_BONUS);
		//if (index == 3) return "" + (int) (100f * CARGO_PENALTY);
		//if (index == 3) return "halved";
		
		return null;
	}
        @Override
        public void advanceInCombat(ShipAPI ship, float amount) {
            String raceId = "null";
            if (Global.getCombatEngine().isMission()) {
                raceId = Global.getCombatEngine().getMissionId();
            } else {
                return;
            }
            // Race IDs:
            // null        = Not a mission
            // dara_race01 = Waypoint Time Trial
            // dara_race02 = Hailstorm Alley
            
            ShipAPI player = Global.getCombatEngine().getPlayerShip();
            if (ship != player) {
                if (!ship.isAlly()) {
                    ship.setAlly(true);
                }
                return;
            }
            
            numMods = ship.getVariant().getNonBuiltInHullmods().size();
            
            if (!raceInitOnce) {
                counter = 0f;
                if (raceId.contains("dara_race01")) {
                    counter = (R1_HULLMOD_PENALTY * numMods);
                } else if (raceId.contains("dara_race02")) {
                    counter = (R2_HULLMOD_PENALTY * numMods) + R2_INIT_TIME;
                    counter = counter - RACE_GRACE_PERIOD;
                }
                //counter = counter - RACE_GRACE_PERIOD;
                raceInitOnce = true;
            }
            
            if (race01Done == false && race02Done == false) {   // If no race is done...
                counter += amount;
                Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY1, null, "race in progress", "time: " + (int) counter + " seconds", true);
            }
            
            if (graceCounter > 0) {
                graceCounter -= amount;
                return;
            }
            //Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY3, null, "race in progress", "" + raceId, true);
            
            
            //checkTimer += amount;
            //ShipSystemAPI sys = ship.getSystem();
            //ShipSystemAPI travel = ship.getSystem();
            //SystemState sysState = sys.getState();
            //SystemState travelState = travel.getState();
            //if (Global.getCombatEngine().getTotalElapsedTime(false) < 2.0f) {
            //    return;
            //} else if (Global.getCombatEngine().getTotalElapsedTime(false) < 2.1f) {
            //    nextSpeedCheck = (float) ship.getVelocity().length();
            //}
            
            
            
            List enemy_ships = new ArrayList<>();
            //List friendly_ships = new ArrayList<>();
            for (ShipAPI this_ship : Global.getCombatEngine().getShips()) {
                if (this_ship.getOriginalOwner() == 1 && this_ship.isAlive()) {
                    enemy_ships.add(this_ship);
                //} else {
                //    if (this_ship != player && this_ship.isAlive()) {
                //        friendly_ships.add(this_ship);
                //    }
                }
            }
            //Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY3, null, "race in progress", "" + (int) enemy_ships.size(), true);
            
            
            // Get our saved racer data, or add it if this ship is new to the battle map
            /*RacerData data = racerData.get(ship);
            if (data == null) {
                data = new RacerData(ship);
                racerData.put(ship, data);
            }

            float curTime = Global.getCombatEngine().getTotalElapsedTime(false);
            //if (curTime >= data.nextCheck) {
                // Do usual checks here (use data.lastVel for previous velocity)
            
                // .. Then set variables for the next set of checks
                //data.lastVel.set(ship.getVelocity());
                //data.nextCheck = curTime + timerDelay;
            //}*/
            
            /*if (raceId.contains("dara_race02")) {
                
                //float shipSpeed = (float) ship.getVelocity().length();
                if (checkTimer > timerDelay) { // && travelState == SystemState.IDLE) {
                //if (curTime >= data.nextCheck && travelState == SystemState.IDLE) {
                    checkTimer = 0f;
                    lastSpeedCheck = nextSpeedCheck;
                    //lastSpeedCheck = (data.lastVel).length();
                    nextSpeedCheck = ship.getVelocity().length();
                    //data.lastVel.set(ship.getVelocity());
                    //data.nextCheck = curTime + timerDelay;
                    float diff = Math.abs(lastSpeedCheck - nextSpeedCheck);
                    if (sysState == SystemState.IDLE || sysState == SystemState.COOLDOWN) {
                    //if (data.state == SystemState.IDLE || data.state == SystemState.COOLDOWN) {
                        mult = 2.0f;
                    } else {
                        mult = 5.5f;
                    }
                    if (diff > (baseDecelMod * mult)) {
                        Global.getCombatEngine().addFloatingText(ship.getLocation(),
                                                            "Collision! " + (int) diff + " dV",
                                                            28f,
                                                            DISPLAY_COLOUR,
                                                            null,   
                                                            2f,
                                                            5f);
                        cumulativeDmg = diff;
                        //float shipMaxHull = ship.getMaxHitpoints();
                        float shipCurrHull = ship.getHitpoints();
                        if (cumulativeDmg >= shipCurrHull) {
                            Global.getCombatEngine().applyDamage(ship, ship.getLocation(),
                                                            1000f,
                                                            DamageType.ENERGY,
                                                            0f,
                                                            false,
                                                            false,
                                                            ship);
                        } else {
                            ship.setHitpoints(shipCurrHull - cumulativeDmg);
                        }
                        //Global.getCombatEngine().applyDamage(ship, ship.getLocation(),
                        //                                    (diff * 3f),
                        //                                    DamageType.ENERGY,
                        //                                    0f,
                        //                                    false,
                        //                                    false,
                        //                                    ship);
                    }
                }
                if (ship != player) {
                    return;
                } else {
                    Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY2, null, "ship speed - last check / this check", "" + (int) lastSpeedCheck + " / " + (int) nextSpeedCheck, true);
                    Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY3, null, "collision check threshold", "" + (int) (baseDecelMod * mult), true);
                    return;
                }
            }*/
            
            if (enemy_ships.isEmpty() && raceId.contains("dara_race01")) {    // Criteria for race 1 to be completed:
                race01Done = true;          // - No enemy ships remain
            }
            //if (ship.isRetreating()) {    // Criteria for race 2 to be completed:
            if (ship.getTravelDrive().getState() == SystemState.ACTIVE
                         && raceId.contains("dara_race02")) {    
                race02Done = true;          // - Player ship is retreating off the map
            }
            
            if (race01Done == false && race02Done == false) {   // If no race is done...
                //counter = counter + amount;
                displayTimeOnce = false;
                //Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY1, null, "race in progress", "time: " + (int) counter + " seconds", true);
                if (raceId.contains("dara_race01")) {
                    Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY3, null, "race in progress", "" + (int) enemy_ships.size() + " markers remaining", true);
                }
            } else {
                Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY1, null, "stop the clock!", "time: " + (int) counter + " seconds", true);
                if (!displayTimeOnce) {
                    Vector2f scoreLoc1 = MathUtils.getPointOnCircumference(ship.getLocation(), 200f, 90f);
                    Vector2f scoreLoc2 = MathUtils.getPointOnCircumference(ship.getLocation(), 250f, 90f);
                    Global.getCombatEngine().addFloatingText(scoreLoc1,
                                                            "Race time: " + (int) counter + " seconds",
                                                            28f,
                                                            DISPLAY_COLOUR,
                                                            null,
                                                            2f,
                                                            5f);
                    Global.getCombatEngine().addFloatingText(scoreLoc2,
                                                            "Stop the clock!",
                                                            36f,
                                                            DISPLAY_COLOUR,
                                                            null,
                                                            0f,
                                                            5f);
                    displayTimeOnce = true;
                }
            }
            if (numMods > 0) {
                Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEY2, null, "modifications present!", "" + numMods + " penalties incurred", true);
            }
        }
        /*private class RacerData {
            private final Vector2f lastVel = new Vector2f();
            private float nextCheck;
            private SystemState state;

            private RacerData(ShipAPI ship)
            {
                nextCheck = Global.getCombatEngine().getTotalElapsedTime(false);
                lastVel.set(ship.getVelocity());
                state = ship.getSystem().getState();
            }
        }*/
}
