package data.scripts.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class dara_StrippedBays extends BaseHullMod {

	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getNumFighterBays().modifyMult(id, 0f);   // No fighter bays for you!
	}
        
        @Override
        public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {
            
            // Counter any carrier-related D-mods that could otherwise appear due to the base
            // hull having fighter bays.
            if (ship.getVariant().hasHullMod("malfunctioning_comms")) {
                    ship.getVariant().removeMod("malfunctioning_comms");
                }
            if (ship.getVariant().hasHullMod("defective_manufactory")) {
                    ship.getVariant().removeMod("defective_manufactory");
                }
            if (ship.getVariant().hasHullMod("damaged_deck")) {
                    ship.getVariant().removeMod("damaged_deck");
                }
        }
	
        @Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		return null;
	}
	


}



