package data.scripts.shipsystems;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.EveryFrameWeaponEffectPlugin;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipSystemAPI;
import com.fs.starfarer.api.combat.ShipSystemAPI.SystemState;
import com.fs.starfarer.api.combat.ShipCommand;
import java.awt.Color;

import java.util.List;
import java.util.ArrayList;
import org.lwjgl.util.vector.Vector2f;
import com.fs.starfarer.api.util.IntervalUtil;
import org.lazywizard.lazylib.MathUtils;

//import java.awt.*;

public class dara_QuandaryChargeEffect implements EveryFrameWeaponEffectPlugin {

    private static final String MAIN_WPN_ID = "dara_enigmamain";     // Firing weapon ID to search for
    private static final String EJECT_WPN_ID = "dara_enigmamain_charge_faux";     // Animated weapon ID to search for
    private Color color = new Color(80,75,125,255);
    private boolean runOnce = false;
    private static final float randAngleRange = 3f;
    
    private final IntervalUtil tracker = new IntervalUtil(0.5f, 1.5f);

    @Override
    public void advance(float amount, CombatEngineAPI engine, WeaponAPI weapon) {
        
        if (engine.isPaused()) {
            return;
        }
        tracker.advance(amount);	// Advance until the given interval has elapsed, then continue.
        if (!tracker.intervalElapsed()) {
            return;
        }
        
        ShipAPI ship = weapon.getShip();
        if (engine.isPaused()) {
            return;
        }
        if (!ship.isAlive()) {
            return;
        }
        
        WeaponAPI main = null;
        for (WeaponAPI this_wpn : ship.getAllWeapons()) {
            if (this_wpn.getId().contains(MAIN_WPN_ID)) {       // Checking a weapon ID match
                main = this_wpn;
            }
        }
        
        if (main.getAmmo() == 0 
                && main.getChargeLevel() == 0f
                && !runOnce) {
            weapon.getAnimation().setFrame(1);
            float angle = weapon.getCurrAngle() + MathUtils.getRandomNumberInRange(randAngleRange, -randAngleRange);
            Global.getCombatEngine().spawnProjectile(ship, weapon, "dara_enigmamain_charge",
			weapon.getLocation(), 
                        angle, 
                        ship.getVelocity());
            Global.getSoundPlayer().playSound("dara_nitro_eject", 
                        1f, 
                        0.4f, 
                        weapon.getLocation(), 
                        weapon.getShip().getVelocity());
            //Global.getCombatEngine().spawnExplosion(weapon.getLocation(),
            //            weapon.getShip().getVelocity(),
            //            color,
            //            30,
            //            0.5f);
            Global.getCombatEngine().addSmokeParticle(weapon.getLocation(),
                        weapon.getShip().getVelocity(),
                        25f,
                        150f,
                        0.75f,
                        color);
            runOnce = true;
        }
        
    }
}
