package data.scripts.weapons;

import java.awt.Color;

import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.DamagingProjectileAPI;
import com.fs.starfarer.api.combat.OnHitEffectPlugin;
import com.fs.starfarer.api.combat.ShipAPI;

public class dara_SwiftOnHitEffect implements OnHitEffectPlugin {

    private final float MAX_BONUS_DAMAGE = 50f;
    private final Color EXPLOSION_COLOUR = new Color(255,75,50,225);
    
    @Override
    public void onHit(DamagingProjectileAPI projectile, CombatEntityAPI target,
					  Vector2f point, boolean shieldHit, CombatEngineAPI engine) {
        
	if (!shieldHit && target instanceof ShipAPI) {
            float bonusDamage = (float) Math.random() * MAX_BONUS_DAMAGE;
            // 0-50 bonus HE damage on hitting hull/armour.
            float effectSize = 20f + (bonusDamage * 2f);
            // 50-125 for visual explosion size
            float effectDur = 0.1f + (bonusDamage / 100f);
            // 0.1-0.6 seconds for visual explosion duration
            
            engine.applyDamage(target, projectile.getLocation(), 
                bonusDamage,                // Damage amount
                DamageType.HIGH_EXPLOSIVE,  // Damage type
                0f,                         // EMP damage
                false,                      // Bypass shields?
                true,                       // Deal soft flux?
                projectile.getSource(),     // Damage source
                true);                      // Play sound?
            
            engine.spawnExplosion(point,    // Spawn location
                target.getVelocity(),       // Velocity to move with
                EXPLOSION_COLOUR,           // Colour
                effectSize,                 // Visual size
                effectDur);                 // Duration (seconds)
	}
    }
}
