package data.scripts.weapons;

import com.fs.starfarer.api.Global;
import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.combat.BeamAPI;
import com.fs.starfarer.api.combat.BeamEffectPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.impl.campaign.ids.Stats;
import com.fs.starfarer.api.util.IntervalUtil;
import java.awt.Color;

public class dara_markerTaggerEffect implements BeamEffectPlugin {

    private final String taggerRedID = "dara_tagger_red";       // Weapon ID
    private final String taggerBlueID = "dara_tagger_blue";     // Weapon ID
    private final String markerRedID = "dara_slalomflag_red";   // Ship ID
    private final String markerBlueID = "dara_slalomflag_blue"; // Ship ID

    private static final Color COLOUR_RED = new Color(255,50,50,150);
    private static final Color COLOUR_BLUE = new Color(50,50,255,150);
    
    protected Object STATUSKEYRED = new Object();
    protected Object STATUSKEYBLUE = new Object();
	
    @Override
    public void advance(float amount, CombatEngineAPI engine, BeamAPI beam) {
	CombatEntityAPI target = beam.getDamageTarget();
	if (target instanceof ShipAPI && target.getOwner() == 1) {
            ShipAPI shipTarget = (ShipAPI) target;
            
            if (beam.getWeapon().getId().contains(taggerRedID)) {
                /*Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEYRED,
                    null, 
                    "tagger effect debug", 
                    "weapon id: " + beam.getWeapon().getId()
                    + " target id: " + shipTarget.getHullSpec().getHullId()
                    + " target owner: " + shipTarget.getOwner(),
                    false);*/
                
                if (shipTarget.getHullSpec().getHullId().contains(markerRedID)) {
                    Global.getCombatEngine().spawnExplosion(shipTarget.getLocation(),
                        new Vector2f(),
                        COLOUR_RED,
                        150,
                        0.5f);
                    Global.getSoundPlayer().playSound("dara_detonate_arm", 
                        0.75f, 
                        1f, 
                        shipTarget.getLocation(), 
                        new Vector2f());
                    shipTarget.setOwner(0);
                    shipTarget.setOriginalOwner(0);
                    //Global.getCombatEngine().removeEntity(shipTarget);
                    /*Global.getCombatEngine().applyDamage(shipTarget, shipTarget.getLocation(), 
			10f, DamageType.ENERGY, 0f,
			false, false, 
			beam.getSource(), false);*/
                    //shipTarget.setHitpoints(0f);
                }
            }
            
            if (beam.getWeapon().getId().contains(taggerBlueID)) {
                /*Global.getCombatEngine().maintainStatusForPlayerShip(STATUSKEYBLUE,
                    null, 
                    "tagger effect debug", 
                    "weapon id: " + beam.getWeapon().getId()
                    + " target id: " + shipTarget.getHullSpec().getHullId(),
                    false);*/
                
                if (shipTarget.getHullSpec().getHullId().contains(markerBlueID)) {
                    Global.getCombatEngine().spawnExplosion(shipTarget.getLocation(),
                        new Vector2f(),
                        COLOUR_BLUE,
                        150,
                        0.5f);
                    Global.getSoundPlayer().playSound("dara_detonate_arm", 
                        0.75f, 
                        1f, 
                        shipTarget.getLocation(), 
                        new Vector2f());
                    shipTarget.setOwner(0);
                    shipTarget.setOriginalOwner(0);
                    //Global.getCombatEngine().removeEntity(shipTarget);
                    /*Global.getCombatEngine().applyDamage(shipTarget, shipTarget.getLocation(), 
			10f, DamageType.ENERGY, 0f,
			false, false, 
			beam.getSource(), false);*/
                    //shipTarget.setHitpoints(0f);
                }
            }
	}
    }
}
