package data.scripts.world.systems;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.impl.campaign.ids.Factions;
import com.fs.starfarer.api.util.Misc;

import com.fs.starfarer.api.impl.campaign.DerelictShipEntityPlugin.DerelictShipData;
import com.fs.starfarer.api.impl.campaign.ids.Entities;
import com.fs.starfarer.api.impl.campaign.procgen.themes.BaseThemeGenerator;
import com.fs.starfarer.api.impl.campaign.procgen.themes.SalvageSpecialAssigner;
import com.fs.starfarer.api.impl.campaign.rulecmd.salvage.special.ShipRecoverySpecial;
import com.fs.starfarer.api.impl.campaign.rulecmd.salvage.special.ShipRecoverySpecial.ShipCondition;

@SuppressWarnings("unchecked")
public class dara_AlGebbar { // implements SectorGeneratorPlugin {

    public void generate(SectorAPI sector) {
	final StarSystemAPI system = sector.getStarSystem("Al Gebbar");

	SectorEntityToken abandonedSkyhook = system.getEntityById("abandoned_station");
	
        abandonedSkyhook.addTag("dara_HiddenCache");

    }
    
    protected void addDerelict(StarSystemAPI system, SectorEntityToken focus, String variantId, 
								ShipCondition condition, float orbitRadius, boolean recoverable) {
	DerelictShipData params = new DerelictShipData(new ShipRecoverySpecial.PerShipData(variantId, condition), false);
	SectorEntityToken ship = BaseThemeGenerator.addSalvageEntity(system, Entities.WRECK, Factions.NEUTRAL, params);
	ship.setDiscoverable(true);
		
	float orbitDays = orbitRadius / (10f + (float) Math.random() * 5f);
	ship.setCircularOrbit(focus, (float) Math.random() * 360f, orbitRadius, orbitDays);
		
	if (recoverable) {
            SalvageSpecialAssigner.ShipRecoverySpecialCreator creator = new SalvageSpecialAssigner.ShipRecoverySpecialCreator(null, 0, 0, false, null, null);
            Misc.setSalvageSpecial(ship, creator.createSpecial(ship, null));
	}	
    }
}









