package data.scripts.world.systems;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.impl.campaign.ids.Factions;
import com.fs.starfarer.api.impl.campaign.ids.Submarkets;
import com.fs.starfarer.api.util.Misc;

import com.fs.starfarer.api.impl.campaign.DerelictShipEntityPlugin.DerelictShipData;
import com.fs.starfarer.api.impl.campaign.ids.Commodities;
import com.fs.starfarer.api.impl.campaign.ids.Entities;
import com.fs.starfarer.api.impl.campaign.procgen.themes.BaseThemeGenerator;
import com.fs.starfarer.api.impl.campaign.procgen.themes.DerelictThemeGenerator;
import com.fs.starfarer.api.impl.campaign.procgen.themes.SalvageSpecialAssigner;
import com.fs.starfarer.api.impl.campaign.rulecmd.salvage.special.BaseSalvageSpecial;
import com.fs.starfarer.api.impl.campaign.rulecmd.salvage.special.ShipRecoverySpecial;
import com.fs.starfarer.api.impl.campaign.rulecmd.salvage.special.ShipRecoverySpecial.ShipCondition;

@SuppressWarnings("unchecked")
public class dara_Corvus { // implements SectorGeneratorPlugin {

    public void generate(SectorAPI sector) {
	final StarSystemAPI system = sector.getStarSystem("Corvus");

	// Asharu abandoned station
	SectorEntityToken neutralStation = system.getEntityById("corvus_abandoned_station");
        SectorEntityToken asharu = system.getEntityById("asharu");
        SectorEntityToken jangala = system.getEntityById("jangala");
		
	//neutralStation.getMarket().getSubmarket(Submarkets.SUBMARKET_STORAGE).getCargo().addMothballedShip(FleetMemberType.SHIP, "dara_junker_Hull", null);
        
        SectorEntityToken probe = DerelictThemeGenerator.addSalvageEntity(system, "dara_derelict_sensorbuoy", Factions.DERELICT);
	probe.setId("dara_test_probe");
	probe.setCircularOrbit(jangala, 120, 280, 25f);
        CargoAPI extraProbeSalvage = Global.getFactory().createCargo(true);
	extraProbeSalvage.addCommodity(Commodities.LOBSTER, 4);
	BaseSalvageSpecial.setExtraSalvage(extraProbeSalvage, probe.getMemoryWithoutUpdate(), -1);

    }
    
    protected void addDerelict(StarSystemAPI system, SectorEntityToken focus, String variantId, 
								ShipCondition condition, float orbitRadius, boolean recoverable) {
	DerelictShipData params = new DerelictShipData(new ShipRecoverySpecial.PerShipData(variantId, condition), false);
	SectorEntityToken ship = BaseThemeGenerator.addSalvageEntity(system, Entities.WRECK, Factions.NEUTRAL, params);
	ship.setDiscoverable(true);
		
	float orbitDays = orbitRadius / (10f + (float) Math.random() * 5f);
	ship.setCircularOrbit(focus, (float) Math.random() * 360f, orbitRadius, orbitDays);
		
	if (recoverable) {
            SalvageSpecialAssigner.ShipRecoverySpecialCreator creator = new SalvageSpecialAssigner.ShipRecoverySpecialCreator(null, 0, 0, false, null, null);
            Misc.setSalvageSpecial(ship, creator.createSpecial(ship, null));
	}	
    }
}









